program CGI6;
{$APPTYPE CONSOLE}
{$DEFINE EDIT}
uses
  Windows,
  SysUtils,
  ActiveX,
  Graphics,
  Classes,
  Forms,
  KAHTMLGrid,
  Unit2;

Var
  Res1 : TGridAction;
  Res2 : TGridAction;

procedure SendHTM;
Var
 SL   : TStringList;
begin
With Datamodule1 do
 Begin
 //********************************************* COMPOSE HTML
 SL := TStringList.Create;
 Try
  SL.Add('<HTML>');
  SL.Add('<HEAD>');
  SL.Add('<style type="text/css">');
  SL.Add('<!-- ');
  SL.Add(KAHTMLGrid1.CSS.CSS.Text);
  SL.Add(' -->');
  SL.Add('</style>');
  SL.Add('</HEAD>');
  SL.Add('<BODY LEFTMARGIN="0" TOPMARGIN="0">');
  SL.Add(KAHTMLGrid1.HTML.Text);
  SL.Add('</BODY>');
  SL.Add('</HTML>');
  //********************************************* SEND TO BROWSER
  Writeln('Content-type: text/html');
  Writeln('');
  Writeln(SL.Text);
 Finally
  SL.Free;
 End;
End;
end;

procedure FillPickLists;
Begin
  With Datamodule1 do
     Begin
       Table3.SQL.Clear;
       Table3.SQL.Add('SELECT EmployeeID,LastName FROM Employees;');
       Table3.Open;
       KAHTMLGrid1.PopulatePickListEx(Table3, 'LastName','EmployeeID',3);
       Table3.Close;

       Table3.SQL.Clear;
       Table3.SQL.Add('SELECT DISTINCT CustomerID FROM Orders;');
       Table3.Open;
       KAHTMLGrid1.PopulatePickList(Table3,'0','2',True);
       Table3.Close;
     End;
End;

begin
  CoInitialize(Nil);
  Datamodule1 := TDataModule1.Create(Nil);
  Try
    With Datamodule1 do
     Begin
       //*********************************************** FIRST BLOCK OF SETTINGS
       KAHTMLGrid1.RowsPerPage := 15;
       KAHTMLGrid1.ImagesURL   := 'GImages/';
       KAHTMLGrid2.ImagesURL   := 'GImages/';
       //*********************************************** REQIUIRED ACTIONS
       Table1.DatabaseName  := KACSS1.ExePath;
       Table2.DatabaseName  := KACSS1.ExePath;
       Table3.DatabaseName  := KACSS1.ExePath;
       Table1.Open;
       Table2.Open;
       KAHTMLGrid1.ReadValues;
       {$IFDEF EDIT}
       //*********************************************** ENTER EDIT MODE
       KAHTMLGrid1.EditMode  := True;
       KAHTMLGrid2.EditMode  := True;
       //*********************************************** FILL PICK LISTS FOR COLUMN 2 and 3
       FillPickLists;
       KAHTMLGrid1.Columns[3].LimitToPickList := True;
       {$ENDIF}
       //*********************************************** PROCESS PARAMETERS SEND FROM CLIENT
       Res1 := KAHTMLGrid1.ProcessParameters;
       Res2 := KAHTMLGrid2.ProcessParameters;
       //*********************************************** DO DEFAULT ACTION FOR EACH GRID
       if Not KAHTMLGrid1.DoDefaultAction(Res1) Then Exit;
       if Not KAHTMLGrid2.DoDefaultAction(Res2) Then Exit;
       //*********************************************** SEND HTML TO BROWSER
       SendHTM;
     End;
  Finally
   //*********************************************** TELL GRIDS THAT JOB IS DONE
   Datamodule1.KAHTMLGrid1.Done;
   Datamodule1.KAHTMLGrid2.Done;
   //*********************************************** CLEANUP
   Datamodule1.Table2.Close;
   Datamodule1.Table1.Close;
   Datamodule1.Free;
   CoUnInitialize;
  End;
end.
